//A typical Breakout-style brick
class Brick extends GameEntity {
  AABB body;      //The bounding box
  color clr = color(255, 191, 0);
  int points = 1; //How many points you get for destroying this brick
  int hits = 1;   //How many times you need to hit the brick to destroy it (unused; all bricks take 1 hit)
  
  int borderWidth = 2; //(purely visual)
  
  Brick(float x, float y, float width, float height){
    body = new AABB(x, y, x + width, y + height);
  }
  
  void draw(){
    if ( dead ){
      return;
    }
    stroke(blendColor(clr, color(60), SUBTRACT));
    strokeWeight(borderWidth);
    strokeCap(ROUND);
    fill(clr);
    rect(
      body.xMin + borderWidth, 
      body.yMin + borderWidth, 
      body.xMax - body.xMin - borderWidth, 
      body.yMax - body.yMin - borderWidth
    );
    
    stroke(blendColor(clr, color(30), ADD));
    line(body.xMin + borderWidth*2, body.yMin + borderWidth*2, body.xMax - borderWidth, body.yMax - borderWidth);
  }
  
  Collision checkForCollision(PLine path, float radius){
    if ( dead || (body == null) ){
      return null;
    }
    return intersectLineWithExpandedAABB(path, body, radius);
  };
  
  void onCollision(Collision collision, Ball ball){
    if ( dead ){
      return;
    }
    state.playSound("hitbrick");
    
    hits--;
    if ( hits <= 0 ){
      die();
    } else {
      state.addPoints(1);
    }
  };
  
  void die(){
    dead = true;
    body = null;
    state.brickDestroyed();
    state.addPoints(points);
  }
}
